const strings = require("../data/strings");

/**
 * This function is used by the NLPManager to recognise the entities in the intents.
 * This process is executed in the DialogManager.
 */
function entitiesCreator(nlpManager) {
  addApplianceEntities(nlpManager);
  addRegionEntities(nlpManager);
}

function addApplianceEntities(nlpManager) {
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.televisionAppliance.id,
    [strings.englishLanguage],
    strings.televisionAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.dishwasherAppliance.id,
    [strings.englishLanguage],
    strings.dishwasherAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.washingmachineAppliance.id,
    [strings.englishLanguage],
    strings.washingmachineAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.driermachineAppliance.id,
    [strings.englishLanguage],
    strings.driermachineAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.fridgeAppliance.id,
    [strings.englishLanguage],
    strings.fridgeAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.airconditionerAppliance.id,
    [strings.englishLanguage],
    strings.airconditionerAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.microwaveAppliance.id,
    [strings.englishLanguage],
    strings.microwaveAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.electricovenAppliance.id,
    [strings.englishLanguage],
    strings.electricovenAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.inductionhobAppliance.id,
    [strings.englishLanguage],
    strings.inductionhobAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.boilerAppliance.id,
    [strings.englishLanguage],
    strings.boilerAppliance[strings.currentLanguage]
  );
  nlpManager.addNamedEntityText(
    strings.applianceEntity,
    strings.entirehouseAppliance.id,
    [strings.englishLanguage],
    strings.entirehouseAppliance[strings.currentLanguage]
  );
}

function addRegionEntities(nlpManager) {
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.abruzzoRegion,
    [strings.englishLanguage],
    [strings.abruzzoRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.basilicataRegion,
    [strings.englishLanguage],
    [strings.basilicataRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.calabriaRegion,
    [strings.englishLanguage],
    [strings.calabriaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.campaniaRegion,
    [strings.englishLanguage],
    [strings.campaniaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.emiliaRomagnaRegion,
    [strings.englishLanguage],
    [strings.emiliaRomagnaRegion, "emilia", "romagna"]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.friuliVeneziaGiuliaRegion,
    [strings.englishLanguage],
    [strings.friuliVeneziaGiuliaRegion, "friuli"]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.lazioRegion,
    [strings.englishLanguage],
    [strings.lazioRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.liguriaRegion,
    [strings.englishLanguage],
    [strings.liguriaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.lombardiaRegion,
    [strings.englishLanguage],
    [strings.lombardiaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.marcheRegion,
    [strings.englishLanguage],
    [strings.marcheRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.moliseRegion,
    [strings.englishLanguage],
    [strings.moliseRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.piemonteRegion,
    [strings.englishLanguage],
    [strings.piemonteRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.pugliaRegion,
    [strings.englishLanguage],
    [strings.pugliaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.sardegnaRegion,
    [strings.englishLanguage],
    [strings.sardegnaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.siciliaRegion,
    [strings.englishLanguage],
    [strings.siciliaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.toscanaRegion,
    [strings.englishLanguage],
    [strings.toscanaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.trentinoAltoAdigeRegion,
    [strings.englishLanguage],
    [strings.trentinoAltoAdigeRegion, "trentino", "alto adige"]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.umbriaRegion,
    [strings.englishLanguage],
    [strings.umbriaRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.valDAostaRegion,
    [strings.englishLanguage],
    [strings.valDAostaRegion, "valle d'aosta", "aosta"]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.venetoRegion,
    [strings.englishLanguage],
    [strings.venetoRegion]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.trentoRegion,
    [strings.englishLanguage],
    [strings.trentoRegion, "provincia autonoma di trento"]
  );
  nlpManager.addNamedEntityText(
    strings.regionEntity,
    strings.bolzanoRegion,
    [strings.englishLanguage],
    [strings.bolzanoRegion, "provincia autonoma di bolzano"]
  );
}

module.exports = entitiesCreator;
